#include "ws2812.h"

static int export_fd;
static int color[3] = {0,0,255}; //RGB

int LED_LiuShui2(){
    int i;
    int mode = 0;
    int R= 0 ,G = 0,B = 0;
    while(1){
        if(i == 32)
        {
            i = 0;
            mode += 1;
        }
        if(mode == 0){
            R = 255; G = 0; B = 0;
        }
        if (mode == 1){
            R = 0; G = 255; B = 0;
        }
        if(mode == 2){
            R = 0; G = 0; B = 255;
        }
        if(mode == 3)
        {
            mode = 0;
            printf("delate 0\n");
        }
        LED_Color(i,R,G,B);
        i++;
        delay_ms(20);
    }
    return 1;
}

int LEDC_LiuShui(){
    int i = 0,len;
    char ledPath[45] = {0};
    char led_write[3] = {0};
    printf("demo 1 \n");
    while(1){
        for(i = 0 ; i < LED_NUM ; i++){
        printf("LED %d \n",i);
        sprintf(ledPath,LEDC_BLUE_PATH,i);
        export_fd = open(ledPath, O_WRONLY);
        if(-1 == export_fd)
        {
            printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
            return -1;
        }
        len = sprintf(led_write,"%d",color[2]);
        if(-1 == write(export_fd, led_write, len))
        {
            printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
            close(export_fd);
            return -1;
        }
        close(export_fd);
        if(i>3){
            sprintf(ledPath,LEDC_BLUE_PATH,i-3);
            export_fd = open(ledPath, O_WRONLY);
            if(-1 == export_fd)
            {
                printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
                return -1;
            }
            len = sprintf(led_write,"%d",0);
            if(-1 == write(export_fd, led_write, len))
            {
                printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
                close(export_fd);
                return -1;
            }
            close(export_fd);
        }
        else {
            sprintf(ledPath,LEDC_BLUE_PATH,i+29);
            export_fd = open(ledPath, O_WRONLY);
            if(-1 == export_fd)
            {
                printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
                return -1;
            }
            len = sprintf(led_write,"%d",0);
            if(-1 == write(export_fd, led_write, len))
            {
                printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
                close(export_fd);
                return -1;
            }
            close(export_fd);
        }
    
        
        delay_ms(50);
    }
    
    }
    printf("demo 1 end \n");
    return 1;
}



int LED_Color(int led,uint8 R,uint8 G,uint8 B)
{
    int len;
    char ledPath[45] = {0};
    char led_write[3] = {0};

    sprintf(ledPath,LEDC_BLUE_PATH,led);
    export_fd = open(ledPath, O_WRONLY);
    if(-1 == export_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }
    len = sprintf(led_write,"%d",B);
    if(-1 == write(export_fd, led_write, len))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(export_fd);
        return -1;
    }
    close(export_fd);

    sprintf(ledPath,LEDC_GREEN_PATH,led);
    export_fd = open(ledPath, O_WRONLY);
    if(-1 == export_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }
    len = sprintf(led_write,"%d",G);
    if(-1 == write(export_fd, led_write, len))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(export_fd);
        return -1;
    }
    close(export_fd);

    sprintf(ledPath,LEDC_RED_PATH,led);
    export_fd = open(ledPath, O_WRONLY);
    if(-1 == export_fd)
    {
        printf("[%s]:[%d] open gpio direction file error\r\n", __FUNCTION__, __LINE__);
        return -1;
    }
    len = sprintf(led_write,"%d",R);
    if(-1 == write(export_fd, led_write, len))
    {
        printf("[%s]:[%d] write operation direction error\r\n", __FUNCTION__, __LINE__);
        close(export_fd);
        return -1;
    }
    close(export_fd);
}


int ColorDecode(uint32 color ,uint8 *R,uint8 *G,uint8 *B){
    *R = (color >> 16) & 0x000011;
    *G = (color >> 8 ) & 0x000011;
    *B = (color >> 0 ) & 0x000011;
}

int LiuSui3(){
    int i;
    int mode = 0;
    uint8 R= 0 ,G = 0,B = 0;
    while(1){
        if(i == 32)
        {
            i = 0;
            mode += 1;
        }
        if(mode == 0){
            ColorDecode(MediumTurquoise,&R,&G,&B);
        }
        if (mode == 1){
            ColorDecode(Gold,&R,&G,&B);
        }
        if(mode == 2){
            ColorDecode(DarkGray,&R,&G,&B);
        }
        if(mode == 3)
        {
            mode = 0;
            printf("delate 0\n");
        }
        LED_Color(i,R,G,B);
        i++;
        delay_ms(20);
    }
    return 1;
}