#ifndef WS2812_H
#define WS2812_H


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>    
#include <sys/stat.h>    
#include <fcntl.h>

typedef unsigned char uint8;
typedef unsigned int uint32;

#define LED_NUM 32

#define LEDC_RED_PATH "/sys/class/leds/sunxi_led%dr/brightness"
#define LEDC_GREEN_PATH "/sys/class/leds/sunxi_led%dg/brightness"
#define LEDC_BLUE_PATH "/sys/class/leds/sunxi_led%db/brightness"

#define delay_ms(x)  (usleep(x*1000))

#define MediumTurquoise 0x48D1CC
#define Gold            0xFFD700
#define DarkGray        0xA9A9A9
#define Magenta         0xFF00FF
#define Yellow          0xFFFF00

int LED_LiuShui2();
int LEDC_LiuShui();
int LED_Color(int led,uint8 R,uint8 G,uint8 B);
int ColorDecode(uint32 color ,uint8 *R,uint8 *G,uint8 *B);
int LiuSui3();




#endif

